<template>
  <div class="books container">
    <div class="books__header">
      <h1 class="books__header-title">Books</h1>
      <a class="waves-effect waves-light btn books__header-button" v-on:click="navigateAddBook()">
        <i class="material-icons right">control_point</i>Add new
      </a>
    </div>

    <table class="books__table responsive-table">
      <thead>
        <tr>
          <th>Name</th>
          <th>Author</th>
          <th>Price</th>
          <th>Options</th>
        </tr>
      </thead>
      <tbody v-if="books.length > 0">
        <tr v-for="book in books" v-bind:key="book.id">
          <td>{{book.name}}</td>
          <td>{{book.author}}</td>
          <td>{{book.price}}</td>
          <td>
            <a
              v-bind:key="book.id"
              class="dropdown-trigger waves-effect waves-light btn books__table-options"
              v-bind:data-target="book.id"
            >
              <i class="material-icons">brightness_low</i>
            </a>

            <ul v-bind:id="book.id" class="dropdown-content">
              <li>
                <a v-on:click="navigateEditBook(book)">
                  <span>Edit</span>
                </a>
              </li>
              <li>
                <a v-on:click="deleteBook(book)">Del</a>
              </li>
            </ul>
          </td>
        </tr>
      </tbody>
      <tfoot v-if="books.length < 1">
        <tr>
          <td class="center" colspan="4">Books not found</td>
        </tr>
      </tfoot>
    </table>
  </div>
</template>

<script>
import axios from "axios/dist/axios";
import materialize from "materialize-css/dist/js/materialize.min.js";

export default {
  name: "BookTable",
  props: {},
  data: () => {
    return {
      books: []
    };
  },
  methods: {
    getBooks() {
      axios({
        method: "get",
        url: "http://localhost:3000/books",
        responseType: "json"
      })
        .then(response => {
          this.books = response.data;
        })
        .catch(e => {
          console.error(e);
        });
    },
    deleteBook(book) {
      axios({
        method: "delete",
        url: `http://localhost:3000/books/${book.id}`
      })
        .then(() => {
          this.books.splice(this.books.indexOf(book), 1);
        })
        .catch(e => {
          console.error(e);
        });
    },
    navigateEditBook(book) {
      this.$router.push({
        path: `/edit/${book.id}`
      });
    },
    navigateAddBook() {
      this.$router.push({
        path: "/add"
      });
    }
  },
  created() {
    this.getBooks();
  },
  updated() {
    const elDropDown = document.querySelectorAll(".dropdown-trigger");
    elDropDown.forEach(dropdown => {
      materialize.Dropdown.init(dropdown, {});
    });
  }
};
</script>

<style scoped>
.books__header {
  display: flex;
  justify-content: space-between;
  align-items: center;
  background: #0b2950;
  margin-top: 20px;
  padding: 20px;
}
.books__header-title {
  display: inline-block;
  color: #fff;
  padding: 0;
  margin: 0;
}
.books__header-button {
  background: #e71455;
}
.books__table {
  background: #fff;
  padding: 20px;
}
.books__table th,
.books__table td {
  padding-left: 20px;
}
.books__table-options {
  background: #0b2950;
}
</style>
